'
'    Copyright  2003, The KPD-Team
'    All rights reserved.
'    http:'www.mentalis.org/
'
'  Redistribution and use in source and binary forms, with or without
'  modification, are permitted provided that the following conditions
'  are met:
'
'    - Redistributions of source code must retain the above copyright
'       notice, this list of conditions and the following disclaimer. 
'
'    - Neither the name of the KPD-Team, nor the names of its contributors
'       may be used to endorse or promote products derived from this
'       software without specific prior written permission. 
'
'  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
'  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
'  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
'  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
'  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
'  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
'  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
'  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
'  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
'  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
'  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
'  OF THE POSSIBILITY OF SUCH DAMAGE.
'
Option Explicit On 
Option Strict On

Imports System
Imports System.Threading

Namespace Org.Mentalis.Multimedia
    Friend Class MediaResult
        Implements IAsyncResult
        Friend Sub New(ByVal cb As AsyncCallback, ByVal stateObject As Object)
            m_StateObject = stateObject
            m_Completed = False
            If (Not cb Is Nothing) Then AddHandler Callback, cb
        End Sub
        Public Sub Notify()
            If (Not m_Completed) Then
                m_Completed = True
                Try
                    RaiseEvent Callback(Me)
                Catch
                End Try
                If (Not m_WaitHandle Is Nothing) Then m_WaitHandle.Set()
            End If
        End Sub
        Public ReadOnly Property IsCompleted() As Boolean Implements IAsyncResult.IsCompleted
            Get
                Return m_Completed
            End Get
        End Property
        Public ReadOnly Property CompletedSynchronously() As Boolean Implements IAsyncResult.CompletedSynchronously
            Get
                Return False
            End Get
        End Property
        Public ReadOnly Property AsyncState() As Object Implements IAsyncResult.AsyncState
            Get
                Return m_StateObject
            End Get
        End Property
        Public ReadOnly Property AsyncWaitHandle() As WaitHandle Implements IAsyncResult.AsyncWaitHandle
            Get
                If (m_WaitHandle Is Nothing) Then m_WaitHandle = New ManualResetEvent(m_Completed)
                Return m_WaitHandle
            End Get
        End Property
        Private m_Completed As Boolean
        Private m_StateObject As Object
        Private m_WaitHandle As ManualResetEvent
        Public Event Callback As AsyncCallback
    End Class
End Namespace